unit DlgFindKey;

{-------------------------------------------------------------------------------
  ExtRes Creator V1.0
  Copyright 2003 Tumbleweeds ICT. All rights reserved 
--------------------------------------------------------------------------------
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  
  Get the latest version of Extres at www.extres.org.
--------------------------------------------------------------------------------
  Author(s): Patrick van Kemenade
  Revision info :  09-10-2003  Created
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask;

type
  TFindKeyDlg = class(TForm)
    btnOk: TButton;
    btnCancel: TButton;
    lblKey: TLabel;
    EditKey: TEdit;
    procedure btnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    key : string;
  end;

var
  FindKeyDlg: TFindKeyDlg;

implementation

{$R *.dfm}

procedure TFindKeyDlg.FormCreate(Sender: TObject);
begin
  key := '';
end;

procedure TFindKeyDlg.FormShow(Sender: TObject);
begin
  EditKey.Text := key;
  EditKey.SetFocus;
end;

procedure TFindKeyDlg.btnOkClick(Sender: TObject);
begin
  if EditKey.Text <> '' then
  begin
    key := EditKey.Text;
    ModalResult := mrOk;
    FindKeyDlg.Hide;
  end
  else
    MessageDlg('Please enter a key.',  mtInformation, [mbOk], 0);
end;

end.
