//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "uMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmExtresViewer *frmExtresViewer;
//---------------------------------------------------------------------------
__fastcall TfrmExtresViewer::TfrmExtresViewer(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmExtresViewer::FormCreate(TObject *Sender)
{
  extResRegister("My Name", "My Registration");  // After registering your copy
                                                 // fill in your name and registration code,
                                                 // the demo popup window will not appear anymore
}
//---------------------------------------------------------------------------

void __fastcall TfrmExtresViewer::btnFindFileClick(TObject *Sender)
{
  if(OpenDialog->Execute())
  {
    EditFilename->Text = OpenDialog->FileName;
    btnView->Enabled = true;
    ListBoxFound->Clear();
    MemoData->Lines->Clear();
    GroupBoxData->Caption = "Data of Resource #";
  }
  else
    btnView->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmExtresViewer::btnViewClick(TObject *Sender)
{
  ListBoxFound->Clear();
  MemoData->Lines->Clear();
  GroupBoxData->Caption = "Data of Resource #";

  HANDLE extResHandle = extResLoad(EditFilename->Text.c_str());    // Load extres file

  if(RadioButtonCustom->Checked && (EditKey->Text.Length() == 16))
  {
    if(extResSetKey(extResHandle, EditKey->Text.c_str()) == 0)     // Set encryption key
    {
      char Buf[256];
      extResLastError(Buf, 256);
      ShowMessage(Buf);
      return;
    }
  }

  if(extResHandle == 0)
  {
    char Buf[256];
    extResLastError(Buf, 256);
    ShowMessage(Buf);
    return;
  }

  for(int i = atoi(EditStart->Text.c_str()); i < atoi(EditEnd->Text.c_str()); i++)
  {
    long size;
    LPSTR str = extResGet(extResHandle, i, &size);                // Get resource
    if(size > 0)
    {
      extResFree(str);                                            // Free resource
      char buf[10];
      sprintf(buf, "%d", i);
      ListBoxFound->Items->Add(buf);
    }
  }
  extResUnload(extResHandle);                                     // Close extres file
}
//---------------------------------------------------------------------------

void __fastcall TfrmExtresViewer::ListBoxFoundClick(TObject *Sender)
{
  HANDLE extResHandle = extResLoad(EditFilename->Text.c_str());  // Load Extres file
  if(extResHandle == 0)
  {
    char Buf[256];
    extResLastError(Buf, 256);
    ShowMessage(Buf);
    return;
  }

  if(RadioButtonCustom->Checked && (EditKey->Text.Length() == 16))
  {
    if(extResSetKey(extResHandle, EditKey->Text.c_str()) == 0)   // Set Encryption key
    {
      char Buf[256];
      extResLastError(Buf, 256);
      ShowMessage(Buf);
      return;
    }
  }

  long size;                                                     // Get resource
  LPSTR str = extResGet(extResHandle, atoi(ListBoxFound->Items->Strings[ListBoxFound->ItemIndex].c_str()), &size);
  if(size > 0)
  {
    MemoData->Lines->Clear();
    MemoData->Lines->Add(str);
    char buf[30];
    sprintf(buf, "Data of Resource #%s", ListBoxFound->Items->Strings[ListBoxFound->ItemIndex]);
    GroupBoxData->Caption = buf;
    extResFree(str);                                             // Free resource
  }
  extResUnload(extResHandle);                                    // Close Extres file
}
//---------------------------------------------------------------------------
void __fastcall TfrmExtresViewer::RadioButtonClick(TObject *Sender)
{
  EditKey->Enabled = RadioButtonCustom->Checked;

  if(EditKey->Enabled)
  {
    EditKey->SetFocus();
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmExtresViewer::EditKeyExit(TObject *Sender)
{
  if(RadioButtonDefault->Focused())  // Key does not matter if user clicked on Default radiobutton
    return;
  if(EditKey->Text.Length() !=  16)
  {
     MessageDlg("Encryptionkey must be 16 bytes.",  mtInformation, TMsgDlgButtons() << mbOK, 0);
     EditKey->SetFocus();
  }
}

